//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
   #include <math.h>
#include "Unit1.h"

//Original formulas of AI/Fight Value are given by
GrayFace (http://wforum.heroes35.net/)
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
int minv(int a,int b)
{
if(a<=b) return a;
else
return b;
}

long CalkDamageCoeff(int Attack,int Defence)
{int A=Attack;
int D=Defence;
long Result=-1;
  int AvgSkill = 4;
  A=A+AvgSkill;
  D=D+AvgSkill;
  if (A>=D)
  {

    Result=1 + minv((((double)(A-D))*0.05), 3);

    }
  else
  {
    Result=1 - minv(((double)(D-A))*0.025, 0.7);
  }
  return Result;
}

stdAttack[159]=
{
4,6,6,6,8,9,10,12,12,12,15,16,20,30,5,6,6,7,9,9,9,9,9,9,15,15,18,
27,3,4,6,7,7,9,11,12,12,12,16,16,19,24,2,4,6,7,10,10,10,10,13,13,
16,16,19,26,5,6,5,5,7,7,10,10,13,13,16 ,18,17,19,4,5,6,6,9,10,9 ,10,
14,15,15,16,19,25,4,5,7,8,8,8,13,13,13,13,15,17,17,19,3,4,5,6,10,
11,7,8,11,12,14,14,16,18,9,10,10,8,11,13,2,2,15,15,0,8,0,11,0,9,0,
12,18,21,50,40,20,30,17,12,4,1,6,7,9,8,14,10,10,0,0,10,40,36,32,
35,25,33,25,25,28};

stdDefence[159]=
{
5,5,3,3,8,9,12,12,7,10,15,16,20,30,3,3,7,7,5,5,8,10,12,12,14,14,18,27,
3,4,6,7,10,10,8,9,12,12,13,13,16,24,3,4,4,4,6,8,10,10,13,13,12,14,21,28,
4,6,5,5,7,7,9,10,10,10,16,18,15,17,3,4,5,6,7,8,9,10,12,15,13,14,19,25,
2,3,5,5,4,4,7,7,11,11,12,13,17,19,5,6,6,8,14,16,9,10,11,12,14,14,18,20,
9,10,8,10,12,12,2,2,13,13,0,10,0,11,0,9,0,8,18,18,50,40,20,30,12,10,2,
1,5,7,8,3,7,10,10,0,5,5,40,36,32,37,23,33,25,27,28};



long CalkAttDamage(int Att)
{
     long Result=-1;
  Result=0;
  for (int i=0;i<=158;i++)
  {
    Result=Result +CalkDamageCoeff(Att, stdDefence[i]);
    }
  Result=Result/159;
  return Result;
  }

long CalkDefDamage(int Def)
{
     long Result=-1;
  Result=0;
  for (int i=0;i<=158;i++)
  {
    Result=Result +CalkDamageCoeff(stdAttack[i], Def);
    }
  Result=Result/159;
  return Result;
  }





long CalkFinal(int AttV, int DefV, double ProtPower, double Mul)
{
long Result=0;
  if (AttV==0){
    Result= 0;
    }
  else
  {
    Result= sqrt(AttV)*pow(DefV, ProtPower)*Mul;
  }
return Result;
}

int CalculateValues(int Attack,int Defence,int HitPoints,int MinDamage,int MaxDamage,int out[2])
{
const   double DmgFactor = 0.5;
const   double   ProtPowerFight = 0.57; // Less for Fight value
const   double   ProtPowerAI = 0.67; // More for AI value
const   double   MulFight = 1;
const   double   MulAI = 0.6;
       int Damage1=MinDamage;
       int Damage2=MaxDamage;

 long FinalV,  FinalAI;
    int AttV=CalkAttDamage(Attack)*(DmgFactor*Damage2+(1-DmgFactor)*Damage1)*50. +1.;
    int DefV=(7./CalkDefDamage(Defence)+1.)*HitPoints + 1.;
    FinalV=CalkFinal(AttV, DefV, ProtPowerFight, MulFight);
    FinalAI=CalkFinal(AttV, DefV, ProtPowerAI, MulAI);
    out[0]=FinalV;
    out[1]=FinalAI;
}





int maxof(int v1,int v2)
{
if(v1<=0) return v2; else return v1;

}

int minof(int v1,int v2)
{
if(v1<=v2) return v1; else return v2;

}


int GetValueFromList(TStringList *templ,AnsiString SearchString)
{
int Level=-1;
for(int g=0;g<templ->Count;g++)
{

AnsiString Cur=SearchString;//    "\"level\"";
int posl=templ->Strings[g].Pos(Cur);
int posComments=templ->Strings[g].Pos("\\");
if((posl!=0)&&((posComments==0)||(posComments>posl))   )
{
 AnsiString LevelStr=templ->Strings[g].SubString(posl+Cur.Length(),templ->Strings[g].Length()-posl);
 LevelStr=LevelStr.Trim();
 if(LevelStr[1]==':')
 {

 LevelStr=LevelStr.SubString(2,minof(maxof(LevelStr.Pos(",")-2,LevelStr.Length()),LevelStr.Length()));

  if(LevelStr[LevelStr.Length()]=='}') LevelStr[LevelStr.Length()]='\0';
 LevelStr.Trim();
 Level=StrToInt(LevelStr);
  break;
  }
}

   }
   return Level;

}



int GetMaxMinFromList(TStringList *templ,AnsiString SearchString, int out[2])
{

 int MaxDamage=-1,MinDamage=-1;

for(int g=0;g<templ->Count;g++)
{

AnsiString Cur=SearchString;//"\"damage\"";
int end=0;
int posl=templ->Strings[g].Pos(Cur);
int posComments=templ->Strings[g].Pos("\\");
if((posl!=0)&&((posComments==0)||(posComments>posl))   )
{

AnsiString CommonString=templ->Strings[g];
int startstr=g;
int endstr=0;

for(int tekstr=g;tekstr< templ->Count;tekstr++)
   {
   int f=templ->Strings[tekstr].Pos("}");
    CommonString=CommonString+templ->Strings[tekstr].Trim();
     if( templ->Strings[tekstr].Pos("}")) { endstr=tekstr;break;}
   }
  if(endstr==0) break;
//search max


Cur="\"max\"";
posl=CommonString.Pos(Cur);
int posComments1=CommonString.Pos("\\");
if((posl!=0)&&((posComments1==0)||(posComments1>posl))   )
if(posl!=0)
{
 AnsiString LevelStr=CommonString.SubString(posl+Cur.Length(),CommonString.Length()-posl);
   if(LevelStr[LevelStr.Length()]=='}') LevelStr[LevelStr.Length()]='\0';
 LevelStr=LevelStr.Trim();
 if(LevelStr[1]==':')
 {

 LevelStr=LevelStr.SubString(2,minof(maxof(LevelStr.Pos(",")-2,LevelStr.Length()),LevelStr.Length()));
   if(LevelStr[LevelStr.Length()]=='}') LevelStr[LevelStr.Length()]='\0';

 LevelStr.Trim();
 MaxDamage=StrToInt(LevelStr);
 // break;
  }
}
 if(MaxDamage==-1) break;

Cur="\"min\"";
posl=CommonString.Pos(Cur);
int posComments2=CommonString.Pos("\\");
if((posl!=0)&&((posComments2==0)||(posComments2>posl))   )
{
 AnsiString LevelStr=CommonString.SubString(posl+Cur.Length(),CommonString.Length()-posl);
 LevelStr=LevelStr.Trim();
 if(LevelStr[1]==':')
 {

 LevelStr=LevelStr.SubString(2,minof(maxof(LevelStr.Pos(",")-2,LevelStr.Length()),LevelStr.Length()));

  if(LevelStr[LevelStr.Length()]=='}') LevelStr[LevelStr.Length()]='\0';
 LevelStr.Trim();
 MinDamage=StrToInt(LevelStr);
  break;
  }
}
  }
 }
  out[0]=MaxDamage;
  out[1]=MinDamage;

if((MinDamage!=-1)&&(MaxDamage!=-1))
  return 0;
  else return -1;

}


int ReplaceValue(TStringList *templ,AnsiString SearchValue,int WriteValue)
{

 int AIValue=-1;
 int AIValueString=-1;
 int AIValueEnd=-1;
 int AIValueStart=-1;
for(int g=0;g<templ->Count;g++)
{

AnsiString Cur=SearchValue;//"\"aiValue\"";
int posl=templ->Strings[g].Pos(Cur);
int posComments=templ->Strings[g].Pos("\\");
if((posl!=0)&&((posComments==0)||(posComments>posl))   )
{
AnsiString Endstr=         templ->Strings[g].SubString(posl,templ->Strings[g].Length()-posl);
AIValueStart=posl+Endstr.Pos(":")-1;
Endstr=Endstr.SubString(1,minof(maxof(Endstr.Pos(",")-1,Endstr.Length()),Endstr.Length()));
AIValueEnd=posl+Endstr.Length()-1;

AIValueString=g;
 AnsiString LevelStr=templ->Strings[g].SubString(posl+Cur.Length(),templ->Strings[g].Length()-posl);
 LevelStr=LevelStr.Trim();
 if(LevelStr[1]==':')
 {

 LevelStr=LevelStr.SubString(2,minof(maxof(LevelStr.Pos(",")-2,LevelStr.Length()),LevelStr.Length()));
   if(LevelStr[LevelStr.Length()]=='}') LevelStr[LevelStr.Length()]='\0';
 LevelStr.Trim();
 AIValue=StrToInt(LevelStr);
  break;
  }
}
}
int AIValueOld=AIValue;
AIValue=WriteValue;

 if(AIValueString!=-1)
{
AnsiString Temp=templ->Strings[AIValueString].SubString(1,AIValueStart);
Temp=Temp+" "+IntToStr(AIValue);
Temp=Temp+templ->Strings[AIValueString].SubString(AIValueEnd+1,templ->Strings[AIValueString].Length()-AIValueStart);
 templ->Strings[AIValueString]=Temp;
}

return 0;
}

bool GetBooleanAbilityExistence(TStringList *templ,AnsiString FindWhat)
{
bool IsTrue=false;
for(int g=0;g<templ->Count;g++)
{
int posl=templ->Strings[g].Pos(FindWhat);
int posType=templ->Strings[g].Pos("\"type\"");

int posComments=templ->Strings[g].Pos("\\");
 if((posl!=0)&&(posl>posType)&&((posComments==0)||(posComments>posl))   )

//if(templ->Strings[g].Pos("\"SHOOTER\"")||templ->Strings[g].Pos("\"SPELL_AFTER_ATTACK\"")||templ->Strings[g].Pos("\"SPELL_BEFORE_ATTACK\""))
{
IsTrue=true;
  break;
  }
}
 return IsTrue;
}



TForm1 *Form1;




int      correctValues(AnsiString FilePath)
{


      int FightValue=-1;
 int FightValueString=-1;
 int FightValueEnd=-1;
 int FightValueStart=-1;

    int AIValue=-1;
 int AIValueString=-1;
 int AIValueEnd=-1;
 int AIValueStart=-1;

int res=0;
TStringList *templ=new TStringList;
templ->LoadFromFile(FilePath);
//Search for level of creature
AnsiString a;

int Level=GetValueFromList(templ,"\"level\"");
int HitPoints=GetValueFromList(templ,"\"hitPoints\"");

int AttackSkill=GetValueFromList(templ,"\"attack\"");
int DefenceSkill =GetValueFromList(templ,"\"defense\"");
int Speed =GetValueFromList(templ,"\"speed\"");



bool IsShooter=GetBooleanAbilityExistence(templ,"\"SHOOTER\"");
bool IsSpellAfterAttack=GetBooleanAbilityExistence(templ,"\"SPELL_AFTER_ATTACK\"");
bool IsSpellBeforeAttack=GetBooleanAbilityExistence(templ,"\"SPELL_BEFORE_ATTACK\"");
bool IsTwoHex=GetBooleanAbilityExistence(templ,"\"TWO_HEX_BREATH_ATTACK\"");
bool IsThreeHeadedAttack=GetBooleanAbilityExistence(templ,"\"THREE_HEADED_ATTACK\"");
bool IsAttacksAllAdjacent=GetBooleanAbilityExistence(templ,"\"ATTACKS_ALL_ADJACENT\"");
bool IsDeathStare=GetBooleanAbilityExistence(templ,"\"DEATH_STARE\"");
bool IsAcidBreath=GetBooleanAbilityExistence(templ,"\"ACID_BREATH\"");
bool IsFireShield=GetBooleanAbilityExistence(templ,"\"FIRE_SHIELD\"");

int outValue[2]={-1,-1};
 int MaxDamage=-1,MinDamage=-1;
if(GetMaxMinFromList(templ,"\"damage\"",outValue)==0)
{
MaxDamage=outValue[0];
MinDamage=outValue[1];

}
int CorrMaxDamage=MaxDamage;
int CorrMinDamage=MinDamage;
if(IsTwoHex==true) {CorrMaxDamage=CorrMaxDamage*2;CorrMinDamage=CorrMinDamage*2;}
if(IsThreeHeadedAttack==true) {CorrMaxDamage=CorrMaxDamage*3;CorrMinDamage=CorrMinDamage*3;}
if(IsAttacksAllAdjacent==true) {CorrMaxDamage=CorrMaxDamage*4;CorrMinDamage=CorrMinDamage*4;}
//if(IsDeathStare|| IsAcidBreath||  IsFireShield)
//{CorrMaxDamage=CorrMaxDamage*3/2;CorrMinDamage=CorrMinDamage*3/2};



 AIValue=-1;
 AIValueString=-1;
 AIValueEnd=-1;
 AIValueStart=-1;

  FightValue=-1;
  FightValueString=-1;
  FightValueEnd=-1;
  FightValueStart=-1;


if(MaxDamage==-1) return (-1);
if(MinDamage==-1) return (-1);
if( DefenceSkill ==-1) return (-1);
 if( AttackSkill ==-1) return (-1);
if( Level ==-1) return (-1);
    if(HitPoints==-1) return (-1);

AnsiString SaveName=FilePath+"_back";
templ->SaveToFile(SaveName);

 //write new data





int out[2]={0,0};

int resf=CalculateValues(AttackSkill,DefenceSkill,HitPoints,MinDamage,MaxDamage,out);
FightValue=out[0];
AIValue=out[1];


 int res1=ReplaceValue(templ,"\"aiValue\"",AIValue);
 int res2=ReplaceValue(templ,"\"fightValue\"",FightValue);


templ->SaveToFile(FilePath);

return 0;
}

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonStartClick(TObject *Sender)
{
if(OpenDialog1->Execute())
{
this->ButtonStart->Enabled=false;
this->ButtonExit->Enabled=false;

for(int i=0;i< OpenDialog1->Files->Count;i++) //

  {
  int ret=correctValues(OpenDialog1->Files->Strings[i]);
  if(ret!=0) ShowMessage("Error working with "+OpenDialog1->Files->Names[i]);
  }

}
ShowMessage("Calculation is finished!");
this->ButtonStart->Enabled=true;
this->ButtonExit->Enabled=true;

}
//---------------------------------------------------------------------------


void __fastcall TForm1::ButtonExitClick(TObject *Sender)
{
exit(0);        
}
//---------------------------------------------------------------------------

